include \masm32\include\masm32rt.inc

DialogProc proto :DWORD, :DWORD, :DWORD, :DWORD

.data

bReadPipe			DWORD						1

.data?

dwReadHandle		DWORD						?
dwWriteHandle		DWORD						?

PipeAttributes		SECURITY_ATTRIBUTES			<>
StartupInfo			STARTUPINFO					<>
ProcessInfo			PROCESS_INFORMATION			<>

hEdt				DWORD						?
szBuffer			BYTE 1024 DUP				(?)
szBuffer2			BYTE 1024 DUP				(?)

hThread				DWORD						?
nBytesWritten		DWORD						?

CommonControlsEx	INITCOMMONCONTROLSEX		<>

.const

IDD_DLG1			EQU							1000
IDC_EDT1			EQU							1001
IDC_EDT2			EQU							1002
IDC_BTN1			EQU							1003

.code
	Start:

xor ebx, ebx

mov CommonControlsEx.dwSize, sizeof CommonControlsEx
mov CommonControlsEx.dwICC, ICC_WIN95_CLASSES OR ICC_STANDARD_CLASSES
	invoke InitCommonControlsEx, addr CommonControlsEx

	invoke GetModuleHandle, ebx
	invoke DialogBoxParam, ebx, IDD_DLG1, ebx, addr DialogProc, ebx
	invoke ExitProcess, ebx

ReadFromConsole proc hwnd:DWORD
LOCAL nBytesRead:DWORD

	.WHILE bReadPipe

			invoke RtlZeroMemory, addr szBuffer, 1024
			invoke ReadFile, dwReadHandle, addr szBuffer, 1023, addr nBytesRead, NULL
			
			.IF !eax
			
					invoke Sleep, 100
				
			.ELSE		
					invoke GetWindowTextLength, hEdt
					invoke SendMessage, hEdt, EM_SETSEL, eax, eax
					invoke SendMessage, hEdt, EM_REPLACESEL, FALSE, addr szBuffer

			.ENDIF

	.ENDW

	invoke CloseHandle, dwReadHandle
	invoke CloseHandle, dwWriteHandle

ret
ReadFromConsole endp
	
DialogProc proc hwndDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	.IF uMsg == WM_INITDIALOG
		
			invoke GetDlgItem, hwndDlg, IDC_EDT1
		mov hEdt, eax

		mov PipeAttributes.nLength, sizeof PipeAttributes
		mov PipeAttributes.lpSecurityDescriptor, NULL
		mov PipeAttributes.bInheritHandle, TRUE

			invoke CreatePipe, addr dwReadHandle, addr dwWriteHandle, addr PipeAttributes, NULL
		
		mov StartupInfo.cb, sizeof StartupInfo
			invoke GetStartupInfo, addr StartupInfo
		mov eax, dwReadHandle
		mov StartupInfo.hStdInput, eax
			invoke GetStdHandle, STD_OUTPUT_HANDLE
		mov StartupInfo.hStdOutput, eax
			invoke GetStdHandle, STD_ERROR_HANDLE
		mov StartupInfo.hStdError, eax
		
		mov StartupInfo.dwFlags, STARTF_USESHOWWINDOW OR STARTF_USESTDHANDLES
		mov StartupInfo.wShowWindow, SW_HIDE
			invoke CreateProcess, NULL, chr$("C:\Windows\System32\cmd.exe"), NULL, NULL, TRUE, NULL, NULL, NULL, addr StartupInfo, addr ProcessInfo
			invoke CloseHandle, ProcessInfo.hThread
			invoke CreateThread, NULL, NULL, addr ReadFromConsole, hwndDlg, NULL, NULL
		mov hThread, eax
		
	.ELSEIF uMsg == WM_CLOSE
	
		mov bReadPipe, 0
			invoke TerminateProcess, ProcessInfo.hProcess, NULL
			invoke CloseHandle, ProcessInfo.hProcess
			invoke WaitForSingleObject, hThread, INFINITE
			invoke CloseHandle, hThread
			invoke EndDialog, hwndDlg, NULL
		
	.ELSEIF uMsg == WM_COMMAND
	
		mov eax, wParam
		
			.IF ax == IDC_BTN1
				
					invoke GetDlgItemText, hwndDlg, IDC_EDT2, addr szBuffer2, 1024
					invoke WriteFile, dwWriteHandle, addr szBuffer2, 1024, addr nBytesWritten, NULL
				
			.ENDIF
	
			
	
	.ELSE
		
		mov eax, FALSE
		ret
		
	.ENDIF
	
mov eax, TRUE
ret
DialogProc endp
	
	end Start